## parser for input ##
import sys
import re

## Default Strings
bsString = '%%%% Boundary_Sphere_Radius \n sph_rad = %s;\n'
gsString = '%%%% grid-spacing \n grid_spacing  = %s;\n'
snString = '%%%% number of states  \n num_states  = %s;\n'
ftString = '%%%% Fermi Tempserature\n Fermi_temp  = %s;\n'
output = [ bsString, gsString, snString, ftString ]

## Default Values
bsRadius = 10.00
gSpacing = 0.500
stateNum = 10.00
fermiTmp = 300.0
values = [ bsRadius, gSpacing, stateNum, fermiTmp ]

## Search Strings
pat1 = [ 'Boundary_Sphere_Radius:.*\n', 'Grid_Spacing:.*\n', 'States_Num:.*\n', 'Fermi_Temp:.*\n' ]
pat2 = 'Atom_Type:'
pat3 = 'begin Atom_Coord'
pat4 = 'end Atom_Coord'

# This strips all the comments from the file
def readData( ):
  fname = file('./parsec_in.dat', 'r')
  line = ''
  for nextLine in fname:
    nextLine = re.sub('#.*\n','',nextLine)
    line = line + nextLine
  fname.close()
  return line

## This is the beginning of the main program
# Begin by stripping all the comments from the file
line = readData()

# OPEN output file
outfile = file('./parsec_dat.m','w')

# Now look for the data in pat1
for pat in pat1:
  m = re.search(pat,line)
  val = values[ pat1.index(pat) ]
  if m != None:
    s = m.group()
    val = re.sub('[^0-9.]','',s)
  string = (output[ pat1.index(pat) ]) %(val)
  s = str(string)
  outfile.write(s)

## Look for the atom data
m1 = re.findall(pat2 + '.*\n',line)
m2 = re.findall(pat3 + '.*?' + pat4,line,re.S)

## atom lines
outfile.write('%% at = number of atom type:\n')
outfile.write(' at = 0; \n') 

## Now we output the individual atoms and their coordinates
for at in m1:
# These lines are for the atomic symbol
  outfile.write('%% New atom. Type :\n')
  at_typ = (re.sub(pat2,'',at)).strip()
  outfile.write(' typ = {\'' + at_typ + '\'};\n')
# These lines are for the coordinates
  s = m2[ m1.index(at) ]
  s = re.sub(pat3+'|'+pat4,'',s).strip()
  outfile.write('%% atoms positions \n')
  outfile.write('xyz = [ ' + s + ' ] ; \n')
  outfile.write('%% end Atom_Coord\n')
# These lines build the struct
  outfile.write(" str=struct('typ',typ,'coord',xyz); \n")
  outfile.write(' at = at+1; \n')
  outfile.write(" Atoms(at) = str; \n")

outfile.close()
